3.1. Create an Order to Charge the Customer
You have to create a new order every time you want to charge your customers. This order is different from the one created during the authorisation transaction.POST /orders
Request Parameters
amount mandatory
: integer Amount in currency subunits. For cards, the minimum value is 100 (₹1).
currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
receipt optional
: string A user-entered unique identifier for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
notification
: object Details of the pre-debit notification. This object is optional. You should use it only if you want to control pre-debit notifications and debits. If you do not pass this object, we will automatically try to debit 25 hours after the pre-debit notification is delivered.
token_id mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.
payment_after optional
: integer UNIX timestamp post which the debit is supposed to happen. Defaults to 25 hours after the pre-debit notification is delivered.
notes optional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:
true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.
entity
: string The entity that has been created. Here it is order.
amount
: integer Amount in currency subunits.
amount_paid
: integer The amount that has been paid.
amount_due
: integer The amount that is yet to pay.
currency
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
receipt
: string A user-entered unique identifier of the order. For example, rcptid #1.
status
: string The status of the order.
notes
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer The Unix timestamp at which the order was created.
Error Response Parameters
Given below is a list of possible errors you may face while creating an Order.3.2. Create a Recurring Payment
Once you have generated anorder_id, use it with the token_id to create a payment and charge the customer. The following endpoint creates a payment to charge the customer.
POST /payments/create/recurring
- We recommend sending a pre-debit notification to the customer 24 hours before the debit date.
- For UPI, it may take between 24-36 hours for the subsequent payment to reflect on your Dashboard.
- This is because of the failure of pre-debit notification and/or any retries that we attempt for the payment.
- Do not create another subsequent payment until you get the status of the previous one.
Request Parameters
email mandatory
: string The customer’s email address. For example, gaurav.kumar@example.com.
contact mandatory
: integer The customer’s phone number. For example, 9876543210.
currency mandatory
: string 3-letter ISO currency code for the payment. Currently, only INR is allowed.
amount mandatory
: integer The amount you want to charge your customer. This should be the same as the order amount.
order_idmandatory
: string The unique identifier of the order created. For example, order_1Aa00000000002.
customer_id mandatory
: string The unique identifier of the customer you want to charge. For example, cust_1Aa00000000002.
token mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.
recurring mandatory
: boolean Determines whether recurring payment is enabled or not.
true: Recurring payment is enabled.false: Recurring payment is not enabled.
descriptionoptional
: string A user-entered description for the payment. For example, Creating recurring payment for Gaurav Kumar
notesoptional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.
Response Parameters
razorpay_payment_id
: string The unique identifier of the payment that is created. For example, pay_1Aa00000000001.
razorpay_order_id
: string The unique identifier of the order that is created. For example, order_1Aa00000000001.
razorpay_signature
: string The signature generated by the Razorpay. For example, 9ef4dffbfd84f1318f6739a3ce19f9d85851857ae648f114332d8401e0949a3d
Error Response Parameters
Given below is a list of possible errors you may face while creating a Recurring Payment.adequate_funds_not_available_blocked
adequate_funds_not_available_blocked
- Description: Sufficient unblocked funds not available in customer’s account. Please ask customer to add fund and try again.
- Next Steps: Please ask customer to add sufficient unblocked funds and try again.
amount_does_not_match_mandate_amount
amount_does_not_match_mandate_amount
Amount Mismatch - Mandate Amount
Amount Mismatch - Mandate Amount
- Description: The payment failed as the amount does not match the amount provided at the time of mandate creation.
- Next Steps: Pass the transaction amount less than or equal to the mandate amount.
Amount Mismatch - Payment Amount
Amount Mismatch - Payment Amount
- Description: The amount does not match with payment amount.
- Next Steps: Retry with correct amount.
bad_request_error
bad_request_error
- Description: Invalid Mandate Sequence Number.
- Next Steps: Retry after some time during the valid cycle.
bank_account_invalid
bank_account_invalid
- Description: Payment failed because Account linked to VPA is invalid.
- Next Steps: Create a new mandate with the customer.
bank_not_available
bank_not_available
- Description: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
bank_technical_error
bank_technical_error
Bank Decline
Bank Decline
- Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Bank or Wallet Gateway Error
Bank or Wallet Gateway Error
- Description: Payment processing failed due to error at bank or wallet gateway
- Next Steps: Retry after some time.
Temporary Bank Issue
Temporary Bank Issue
- Description: Payment was unsuccessful due to a temporary issue at your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
General Temporary Issue
General Temporary Issue
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Bank Services Halt
Bank Services Halt
- Description: Payment was unsuccessful due to a temporary halt of services at this bank.
- Next Steps: Retry after some time.
banks_hsm_is_down_remitter
banks_hsm_is_down_remitter
- Description: Remitter bank failed to process the transaction. Please try again after some time.
- Next Steps: Please try again after some time.
credit_to_beneficiary_failed
credit_to_beneficiary_failed
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
debit_declined
debit_declined
- Description: Payment was unsuccessful as it was declined by remitter bank.
- Next Steps: Create a new mandate with the customer.
debit_instrument_blocked
debit_instrument_blocked
- Description: Payment was unsuccessful as the account linked to this UPI ID is blocked. Try using another account.
- Next Steps: Create a new mandate with the customer.
execution_day_rule_mismatch
execution_day_rule_mismatch
Execution Day Rule Mismatch
Execution Day Rule Mismatch
- Description: Day of debit does not match the debit execution rule for the payer. Please ensure execution day matches the execution rule.
- Next Steps: Please ensure execution day matches execution rule.
Execution Day Rule Mismatch - Remitter
Execution Day Rule Mismatch - Remitter
- Description: Day of debit does not match the debit execution rule for the payer. Please ensure execution day matches the execution rule.
- Next Steps: Please ensure execution day matches execution rule and try again.
gateway_technical_error
gateway_technical_error
Bank or Wallet Gateway Error
Bank or Wallet Gateway Error
- Description: Payment processing failed due to error at bank or wallet gateway.
- Next Steps: Retry after some time.
Temporary Issue with Money Deduction
Temporary Issue with Money Deduction
- Description: Payment was unsuccessful due to a temporary issue. If money got deducted, reach out to the seller.
- Next Steps: Retry after some time.
id_value_must_be_present
id_value_must_be_present
- Description: Failed to debit customer’s bank account. Mandate details are incorrect.
- Next Steps: Please try after sometime.
insufficient_funds
insufficient_funds
- Description: Transaction failed due to insufficient funds.
- Next Steps: Ask the customer to add balance to their account and retry.
invalid_response_from_gateway
invalid_response_from_gateway
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
invalid_token
invalid_token
- Description: Invalid Token.
- Next Steps: Create a new mandate with the customer.
invalid_transaction_beneficiary
invalid_transaction_beneficiary
- Description: Beneficiary address resolution failed. Please try again after some time.
- Next Steps: Please try again after some time.
invalid_vpa
invalid_vpa
- Description: You have entered an incorrect UPI ID. Please retry with the correct UPI ID.
- Next Steps: Ask the customer to retry with a valid VPA.
issuer_dispatch_failed
issuer_dispatch_failed
- Description: Payment failed due to some issue at the issuer bank. Please try again after some time.
- Next Steps: Please try again after some time.
limit_exceeded_remitting_bank
limit_exceeded_remitting_bank
- Description: Limit exceeded for remitter bank. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with another bank account.
mandate_cancelled
mandate_cancelled
- Description: UPI mandate created for payment has been cancelled by user.
- Next Steps: Create a new mandate with the customer.
mandate_current_cycle_allowed_debit_exceeds
mandate_current_cycle_allowed_debit_exceeds
- Description: Mandate is already honoured.
- Next Steps: Wait till next cycle for debiting the customer.
mandate_debit_beyond_psp_amount_cap
mandate_debit_beyond_psp_amount_cap
- Description: Debit amount is beyond payer PSP specified amount cap. Please reduce the amount and try again.
- Next Steps: Please reduce the mandate amount to match customer PSP.
mandate_expired
mandate_expired
- Description: UPI Mandate is expired.
- Next Steps: Create a new mandate with the customer.
mandate_not_active
mandate_not_active
- Description: UPI mandate is not active.
- Next Steps: Create a new mandate with the customer.
mandate_paused
mandate_paused
- Description: UPI mandate is not active, it is paused by user.
- Next Steps: Ask the customer to resume the mandate & retry.
merchant_error_payee_psp
merchant_error_payee_psp
- Description: VPA resolution into bank account details failed. Please try again after some time.
- Next Steps: Please try again after some time.
mobile_number_invalid
mobile_number_invalid
- Description: Registered Mobile number linked to the account has been changed or removed.
- Next Steps: Create a new mandate with the customer.
mpin_not_set_by_customer
mpin_not_set_by_customer
- Description: UPI MPIN not set by customer. Please ask customer to set MPIN and try again.
- Next Steps: Please ask customer to set MPIN and try again.
nature_of_debit_not_allowed
nature_of_debit_not_allowed
- Description: Nature of debit not allowed in customer’s account. Please ask the customer to use a different bank account.
- Next Steps: Please ask the customer to use a different bank account.
no_financial_address_record_found
no_financial_address_record_found
- Description: No financial address record found for this vpa. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with other bank account.
no_original_request_found
no_original_request_found
- Description: No mandate details were found in the record during debit. Please try after some time.
- Next Steps: Please try after some time.
null_ack_processing_failure
null_ack_processing_failure
- Description: Processing failure at gateway. Please try again after some time.
- Next Steps: Please try again after some time.
number_of_pin_tries_exceeded
number_of_pin_tries_exceeded
- Description: Customer has exceeded PIN retry limit. Please ask customer to create a new mandate and enter the right PIN.
- Next Steps: Please ask customer to create a new mandate and enter the right PIN.
payer_account_has_changed
payer_account_has_changed
- Description: Payer account linked to the customer’s VPA has changed. Please request the customer to either change it to the bank account used during mandate registration or register a new mandate for them.
- Next Steps: Please request the customer to either change it to the bank account used during mandate registration or register a new mandate for them.
payer_seqnum_validation_failure
payer_seqnum_validation_failure
- Description: Payer sequence number length validation failed.
- Next Steps: Please provide a valid payer sequence number (1-3 digits).
payment_failed
payment_failed
Temporary Issue with Refund
Temporary Issue with Refund
- Description: Payment was unsuccessful due to a temporary issue. If amount got deducted, it will be refunded within 5-7 working days.
- Next Steps: Retry after 1 hour.
Try Another Bank Account
Try Another Bank Account
- Description: Payment failed. Please try again with another bank account.
- Next Steps: Retry after some time.
payment_pending
payment_pending
- Description: The status of your payment is pending. You can either wait or retry to pay successfully.
- Next Steps: Retry after some time.
payment_risk_check_failed
payment_risk_check_failed
- Description: Payment was unsuccessful as your account does not pass the risk checks done by your bank. Try using another account.
- Next Steps: Retry after some time.
payment_stopped_by_court_order
payment_stopped_by_court_order
- Description: Payment processing failure at remitter bank. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with another bank account.
payment_timed_out
payment_timed_out
- Description: Payment was unsuccessful as the bank linked to this UPI ID is not reachable at this time.
- Next Steps: Retry after some time.
per_transaction_limit_exceeded
per_transaction_limit_exceeded
- Description: Customer bank per transaction limit exceeded. Please try again with a lower amount.
- Next Steps: Please reduce transaction amount and try again.
psp_bank_not_available
psp_bank_not_available
- Description: Payer PSP / Bank not available. Please try again after some time.
- Next Steps: Please try again after some time.
psp_not_available
psp_not_available
- Description: Payment was unsuccessful as the UPI app is not reachable at this time. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
psp_timeout
psp_timeout
- Description: Payer PSP timed out. Please try again.
- Next Steps: Please try again after some time.
regid_details_must_be_present
regid_details_must_be_present
- Description: Gateway validation failure. Please try after sometime or create a new mandate.
- Next Steps: Please try after sometime or create a new mandate.
remitter_account_dormant
remitter_account_dormant
- Description: Bank Account is closed.
- Next Steps: Create a new mandate with the customer.
remitter_dispatch_failed
remitter_dispatch_failed
- Description: Payment failed due to some issue at the customer’s. Please try again after some time.
- Next Steps: Please try again after some time.
request_timed_out
request_timed_out
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
response_not_received_within_tat
response_not_received_within_tat
- Description: VPA resolution into bank account details failed. Please try again after some time.
- Next Steps: Please try again after some time.
seqnum_mismatch_payer_psp
seqnum_mismatch_payer_psp
- Description: Sequence number mismatch between payer and payee PSP. Please try again after some time.
- Next Steps: Please ask customer to try after sometime.
suspected_fraud_decline
suspected_fraud_decline
- Description: Suspected fraud, transaction declined by customer’s bank. Please try again after some time.
- Next Steps: Please try after sometime.
transaction_frequency_limit_exceeded
transaction_frequency_limit_exceeded
- Description: Payment failed. Please try again with another bank account.
- Next Steps: Create a new mandate with the customer.
transaction_limit_exceeded
transaction_limit_exceeded
- Description: Payment failed because Transaction amount limit has exceeded
- Next Steps: Reach out to the customer to collect the amount.
transaction_not_allowed
transaction_not_allowed
- Description: Payment was unsuccessful as it was declined by your bank. Reach out to your bank for more details. Try using another account.
- Next Steps: Create a new mandate with the customer.
transaction_not_permitted_cardholder
transaction_not_permitted_cardholder
- Description: Transaction not permitted for customer’s account. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with another bank account.
transaction_not_permitted_cardholder_beneficiary
transaction_not_permitted_cardholder_beneficiary
- Description: Transaction not permitted in beneficiary account. Please try again with another bank account.
- Next Steps: Please try again with another bank account.
transaction_not_permitted_to_vpa
transaction_not_permitted_to_vpa
- Description: Transaction not permitted to payee VPA by the payer PSP. Please contact your bank to enable Autopay for this VPA.
- Next Steps: Please contact your bank to enable autopay for this VPA.
umn_does_not_exist_payer
umn_does_not_exist_payer
- Description: Mandate does not exist. Please create a new mandate.
- Next Steps: Please ask customer to create new mandate.
unable_to_process_beneficiary_bank
unable_to_process_beneficiary_bank
- Description: Error processing request at beneficiary bank. Please try again after some time.
- Next Steps: Please try again after some time.
vpa_resolution_failed
vpa_resolution_failed
- Description: You have entered an incorrect UPI ID. Please retry with the correct UPI ID.
- Next Steps: Retry after some time.
3.3. Fetch an Order With ID
Use this endpoint to retrieve details of a particular order as per the id.GET /v1/orders/:id
Path Parameter
id mandatory
: string Unique identifier of the order to be retrieved.
Response Parameters
id
: string The unique identifier of the order.
amount
: integer The amount for which the order was created, in currency subunits. For example, for an amount of ₹295, enter 29500.
entity
: string Name of the entity. Here, it is order.
amount_paid
: integer The amount paid against the order.
amount_due
: integer The amount pending against the order.
currency
: string ISO code for the currency in which you want to accept the payment. The default length is 3 characters. Refer to the list of supported currencies.
receipt
: string Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.
notification
: object Details of the pre-debit notification. The notification object is populated in the response only if you have passed this while creating an order.
token_id
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.
payment_after
: integer Unix timestamp post which the debit is supposed to happen.
id
: string Unique identifier of the notification.
delivered_at
: integer Indicates the unix timestamp when the notification was delivered.
status
: string The status of the order. Possible values:
created: When you create an order it is in thecreatedstate. It stays in this state till a payment is attempted on it.attempted: An order moves fromcreatedtoattemptedstate when a payment is first attempted on it. It remains in theattemptedstate till one payment associated with that order is captured.paid: After the successful capture of the payment, the order moves to thepaidstate. No further payment requests are permitted once the order moves to thepaidstate. The order stays in thepaidstate even if the payment associated with the order is refunded.
attempts
: integer The number of payment attempts, successful and failed, that have been made against this order.
notes
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer Indicates the Unix timestamp when this order was created.